// Generated by CoffeeScript 2.7.0
/*

Completer plugin
================

Provides tab completion. Options passed during creation are:

-   `shell`  , (required) A reference to your shell application.

*/
module.exports = function(settings) {
  var shell;
  if (!settings.shell) {
    // Validation
    throw new Error('No shell provided');
  }
  shell = settings.shell;
  // Plug completer to interface
  if (!shell.isShell) {
    return;
  }
  shell.interface().completer = function(text, cb) {
    var command, i, len, route, routes, suggestions;
    suggestions = [];
    routes = shell.routes;
    for (i = 0, len = routes.length; i < len; i++) {
      route = routes[i];
      command = route.command;
      if (command.substr(0, text.length) === text) {
        suggestions.push(command);
      }
    }
    return cb(false, [suggestions, text]);
  };
  return null;
};
