// Generated by CoffeeScript 2.7.0
/*

Confirm route
=============

The `confirm` route ask the user if he want to continue the process. If the answer is `true`, the following routes are executed. Otherwise, the process is stoped.

```javascript
var app = new shell();
app.configure(function() {
  app.use(shell.router({
    shell: app
  }));
});
app.cmd('install', [
  shell.routes.confirm('Do you confirm?'),
  my_app.routes.download,
  my_app.routes.configure
]);
```

*/
module.exports = function(message) {
  return function(req, res, next) {
    return req.confirm(message, true, function(confirmed) {
      if (!confirmed) {
        return res.prompt();
      }
      return next();
    });
  };
};
