const { contextBridge, ipcRenderer } = require("electron");

contextBridge.exposeInMainWorld("electronAPI", {
  useToken: (callback) => ipcRenderer.invoke("useToken", callback),
  setWindowSize: (callback) => ipcRenderer.invoke("setWindowSize", callback),
  setCurrentFile: (callback) => ipcRenderer.invoke("setCurrentFile", callback),
  disconnect: (callback) => ipcRenderer.invoke("disconnect", callback),
  go: () => ipcRenderer.invoke("vlc:go"),
  quit: () => ipcRenderer.invoke("quit"),
  pause: () => ipcRenderer.invoke("vlc:pause"),
  play: () => ipcRenderer.invoke("vlc:play"),
  movePosition: (callback) => ipcRenderer.invoke("vlc:movePosition", callback),
  openURL: (callback) => ipcRenderer.invoke("openURL", callback),
  handleStatusUpdate: (callback) => ipcRenderer.on("update-status", callback),
  handleHistory: (callback) => ipcRenderer.on("history", callback),
  handleBadFile: (callback) => ipcRenderer.on("bad-media-file", callback),
  reportConnection: (callback) => ipcRenderer.on("report-connection", callback),
  reportDisconnect: (callback) => ipcRenderer.on("report-disconnect", callback),
  vlcCheck: (callback) => ipcRenderer.on("vlc-check", callback),
  openFile: () => ipcRenderer.invoke("dialog:openFile"),
  reportSavedToken: (callback) =>
    ipcRenderer.on("report-saved-token", callback),
});
